/*
 *  ConnectDialog.h - The connection dialog box
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CONNECTDIALOG_H

#define CONNECTDIALOG_H

#include <qtabdlg.h>
#include <qlabel.h>
#include <qlined.h>
#include <qpushbt.h>
#include <qlist.h>
#include <qlistbox.h>
#include <String.h>

#include "Server.h"

class ConnectDialog : public QTabDialog {
  Q_OBJECT
public:
  ConnectDialog(QWidget *parent=0, const char *name=0);
  ~ConnectDialog();
  void readConfigFile(String filename);

  void config_nickname(String);
  void config_username(String);
  void config_ircname(String);
  void config_server(String);

public slots:
  void apply();
  void addServer();
  void modifyNickname();
  void removeServer();
  void selectedServer(int);
  void enableAddServer();
  void saveConfigFile();
  void reloadConfigFile();

private:
  QList<Server> serverList;
  QListBox *serverListBox;
  QLineEdit *nicknameEdit, *usernameEdit, *ircnameEdit,
            *servernameEdit, *serverportEdit;
  QPushButton *addButton, *removeButton,
              *saveButton, *loadButton;
  String configFile;
};

#endif
