/*
 *  FontSelector.h - The font selection dialog box
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef FONTSELECTOR_H

#define FONTSELECTOR_H

#include <qdialog.h>
#include <qfont.h>
#include <qlistbox.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qstrlist.h>

#include <String.h>

class FontSelector : public QDialog
{
  Q_OBJECT

public:
  FontSelector(QWidget* parent=0, const char* name=0);
  ~FontSelector();

  void setFont(const QFont &font);
  const QFont & getFont(void);

protected slots:
  void repaintText();

protected:
  QListBox * familyBox, * styleBox, *sizeBox;
  QLabel * textDisplay;
  QPushButton *ok, *cancel;
  QStrList families;
};

#endif
