#include <math.h>
#include <String.h>

#include <qlist.h>
#include <qfontmet.h>
#include <qdialog.h>

struct Node {
  double x, y;
  QList<Node> connectedTo;
  String name;
  bool fixed;
};

class LinksWindow : public QDialog
{
public:
  LinksWindow(QWidget *parent = 0, const char *name = 0);
  ~LinksWindow();

  void addLink(String from, String to);
  void doneLinks(void);

  enum { RECEIVING, FINISHED };

protected:
  void create(Node *);
  void rescale(void);
  void rotateNodes(Node *n, double vx, double vy);

  void show();

private:
  QList<Node> nodeList;
  QList<QWidget> widgetList;
  QFontMetrics *fm;
  int status;
};
