/*
 *  LoggingWindow.h - Windows that are capable of logging
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef LOGGINGWINDOW_H

#define LOGGINGWINDOW_H

#include <String.h>
#include <fstream.h>

#include <qwidget.h>
#include <qlined.h>
#include <qpopmenu.h>
#include <qmenubar.h>

#include "Window.h"

class LoggingWindow : public Window
{
  Q_OBJECT

public:
  LoggingWindow(String name);
  virtual ~LoggingWindow();

  virtual void insertLine(String);

protected:
  QPopupMenu *file, *options;
  QMenuBar *menu;

protected slots:
  void setLogOn();
  void setLogOff();
  void closeMe();


private:
  QString logfilename;
  ofstream logfile;
  bool logging;
};

#endif
