/*
 *  MessageWidget.h - The widget used for message display
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MESSAGEWIDGET_H

#define MESSAGEWIDGET_H

#include <String.h>
#include <qtablevw.h>
#include <qcolor.h>
#include <qstrlist.h>

class MessageWidget : public QTableView
{
public:
  MessageWidget(QWidget *parent=0, char *name=0);
  ~MessageWidget();
  
  void clear();
  int numLines() const;

  void insertLine(String);

  enum WrapMode {
    WRAP, DONT_WRAP
  };

  void setWrapMode(WrapMode);
  void setPositionToEnd(void);
  
  void setFont(const QFont &);

protected:
  int line_y, _width;
  QFontMetrics *fm;
  QStrList linebuffer;

  void paintCell(class QPainter *, int row, int col);

/*
private:
  static QColor Colors[16];
*/
};

#endif
