/*
 *  Parser.h - The server-side parser
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef PARSER_H

#define PARSER_H

#include <String.h>

class Parser {
public:
  Parser(int sock);
  ~Parser();

  void parseInput(String);

  void parseError(String, String);
  void parsePing(String, String);
  void parsePrivmsg(String, String);
  void parseNotice(String, String);
  void parseJoin(String, String);
  void parseTopic(String, String);
  void parseMode(String, String);
  void parsePart(String, String);
  void parseKick(String, String);
  void parseKill(String, String);
  void parseQuit(String, String);
  void parseNick(String, String);
  void parse001(String, String); // Welcome to the Internet Relay ...
  void parse324(String, String);
  void parse332(String, String);
  void parse353(String, String);
  void parse364(String, String); // RPL_LINKS
  void parse365(String, String); // RPL_ENDOFLINKS
  void parse366(String, String);
  void parse432(String, String);
  void parse433(String, String);

  void parseCTCP(String, String, String, String);

  static void parseCommand(String, String);

protected:
  String nick;
  int socket;
};

#endif
