/*
 *  Util.h - Miscellaneous utility functions
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef UTIL_H

#define UTIL_H

#include <String.h>
#include <time.h>
#include <qwidget.h>

class Util
{
public:
  static void showMessage(const String title, const String text,
                          QWidget *parent = 0);
  static String convertToAlpha(const String s);
  static String removeNonAlpha(const String s);
  static String escapeString(const String s);
  static void giveHelp(void);
  static void printUsage(void);
  static String removeLeadingBlanks(String s);
  static String removeTrailingBlanks(String s);
  static void send(int socket, const char *format, ...);
  static String receive(int socket);
  static bool isServer(String s);
  static String timeStr(time_t t);
  static String getString(String, String, bool, QWidget *parent = 0);
  static int getArgNumber(String);
  static int do_on(int , ...);
  static bool isChannelName(String);
};

#endif
