/*
 *  Window.h - Base type for windows
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef WINDOW_H

#define WINDOW_H

#include <String.h>
#include <qwidget.h>
#include <qlined.h>

#include "MessageWidget.h"

class Window : public QWidget
{
  Q_OBJECT

public:
  Window(String name);
  virtual ~Window() = 0;

  void clear() const;
  virtual void insertLine(String);

  void setFont(const QFont &);

  String getName(void);

signals:
  void windowClosed(Window *);

protected:
  virtual void resizeEvent(QResizeEvent *);  
  virtual void closeEvent(QCloseEvent *);

  MessageWidget *messageArea;
  QLineEdit *messageEdit;

protected slots:
  virtual void handleInput() = 0;
  virtual void OptionsColors();
  virtual void OptionsFont();

private:
  String _name;
};

#endif
