import raw
import sys
import strop
string=strop
import time
import regex
import posix

VERSION_NUMBER = "0.07"

###################
# The functions exported from the raw module
#
# We must do this way in order to be able to know their number of
# arguments

def echo(message, window = "-"):
  if window == "":
    window = raw.window
  raw.echo(message, strop.lower(window))

def clear(window = "-"):
  if window == "":
    window = raw.window
  raw.clear(strop.lower(window))

def beep():
  raw.beep()

def openwindow(window = "-"):
  raw.open(strop.lower(window))

def closewindow(window):
  raw.close(strop.lower(window))

def existwindow(window):
  return raw.existwindow(strop.lower(window))

def hasnick(channel, nick):
  return raw.hasnick(strop.lower(channel), nick)

def ischanop(channel, nick):
  return raw.ischanop(strop.lower(channel), nick)

def load(s):
  raw.load(s)

def getstring(title, text, passwd = 0):
  return raw.getstring(title, text, passwd)

def nickname():
  return raw.nickname

def window():
  return raw.window

def encode(s):
  res = ''
  for c in s:
    res = res + chr(0x41 + (ord(c) >> 4))
    res = res + chr(0x41 + (0x0f & ord(c)))
  return res

def decode(s):
  res = ''
  i = 0
  while (i < len(s)-1):
    res = res + chr((((ord(s[i])-0x41) << 4) | (ord(s[i+1]) - 0x41)) % 256)
    i = i + 2
  return res

def stime(t):
  return time.asctime(time.localtime(t))

def close(w = ""):
  if w == "":
    w = raw.window
  closewindow(strop.lower(w))

#############
# The commands

# ADMIN
def admin(server = ""):
  raw.send("ADMIN " + server)

# AWAY
def away(text = ""):
  if text == "":
    raw.send("AWAY")
  else:
    raw.send("AWAY :" + text)

# CD
def cd(path = ""):
  if path == "":
    echo("*** Current directory : " + posix.getcwd())
  else:
    try:
      posix.chdir(path)
    except:
      echo("*** " + path + " : No such directory.")

# CTCP
def ctcp(who, what):
  if who == "" or what == "":
    echo("*** Ctcp needs two parameters")
  else:
    raw.send("PRIVMSG " + who + " :\001" + what + "\001")

# CTCP_REPLY
def ctcp_reply(who, what):
  if who == "" or what == "":
    echo("*** Ctcp_reply needs two parameters")
  else:
    raw.send("NOTICE " + who + " :\001" + what + "\001")

# INFO
def info(server = ""):
  raw.send("INFO " + server)

# INVITE
def invite(nick, channel = ""):
  if channel == "":
    if raw.window == "-" or (raw.window[0] != '#' and raw.window[0] != '&'):
      echo("*** Cannot do that in this window", raw.window)
    else:
      raw.send("INVITE " + nick + " " + raw.window)
  else:
    raw.send("INVITE " + nick + " " + channel)

# JOIN
def join(channel, key = ""):
  if channel == "":
    echo("*** Join needs a parameter", raw.window)
  else:
    if key == "":
      raw.send("JOIN " + channel)
    else:
      raw.send("JOIN " + channel + " " + key)

# KICK
def kick(channel = "", nick = "", reason = "Out!"):
  if reason == "":
    reason = "Out!"
  if channel == "" and nick == "":
    echo("*** Kick needs at least one parameter", raw.window)
  else:
    if channel[0] != '#' and channel[0] != '&':
      if raw.window[0] != '#' and raw.window[0] != '&':
        echo("*** Cannot do that in this window", raw.window)
      else:
        raw.send("KICK " + raw.window + " " + channel + " :" + nick + " "+ reason)
    else:
      raw.send("KICK " + channel + " " + nick + " :" + reason)

# KILL
def kill(nick, comment):
  if nick == "" or comment == "":
     echo("*** Kill needs two parameters", raw.window)
  else:
     raw.send("KILL " + nick + " :" + comment)

# LINKS
def links(mask = ""):
  raw.send("LINKS " + mask)

# LIST
def list(channels, server):
  if channels=="":
    raw.send("LIST")
  elif server=="":
    raw.send("LIST " + channels)
  else:
    raw.send("LIST " + channels + " " + server)

# ME
def me(text):
  if raw.window == "-":
    echo("*** Cannot do that in this window")
  else:
    if text == "":
      echo("*** Me needs a parameter", raw.window)
    else:
      raw.send("PRIVMSG " + raw.window + " :\001ACTION " + text + "\001")
      do_on("SEND_ACTION", raw.window, text)

# MODE
def mode(dest = "", modes = "", parameters = ""):
  if dest[0] != '#' and dest[0] != '&':
    parameters = modes + " " + parameters
    modes = dest
    if raw.window=="-":
      dest=""
    else:
      dest = raw.window
  raw.send("MODE " + dest + " " + modes + " " + parameters)

# MOTD
def motd(server = ""):
  raw.send("MOTD " + server)

# MSG
def msg(to, text):
  if to == "" or text == "":
    echo("*** Msg needs two parameters", raw.window)
  else:
    raw.send("PRIVMSG " + to + " :" + text)
    if to[0] == '#' or to[0] == '&':
      do_on("SEND_PUBLIC", to, text)
    else:
      do_on("SEND_MSG", to, text)

# NICK
def nick(n):
  if n == "":
    echo("*** Nick needs a parameter", raw.window)
  else:
    raw.send("NICK " + n)

# NOTICE
def notice(to, text):
  if to == "" or text == "":
    echo("*** Notice needs two parameters", raw.window)
  else:
    raw.send("PRIVMSG " + to + " :" + text)
    do_on("SEND_NOTICE", to, text)

# OPER
def oper(nick, passwd):
  if raw.nickname == "":
    return
  if nick == "":
    nick = raw.nickname
  if passwd == "":
    passwd = getstring("Oper", "Enter operator password", 1)
  raw.send("OPER " + nick + " " + passwd)

# PART
def part(channel = ""):
  if channel == "":
    if raw.window[0] != '#' and raw.window[0] != '&':
      echo("*** Cannot do that in this window", raw.window)
    else:
      channels_status[raw.window] = 'LEFT'
      raw.send("PART " + raw.window)
  else:
    channels_status[channel] = 'LEFT'
    raw.send("PART " + channel)

# PING
def ping(who = ""):
  if who == "":
    if raw.window == "-":
      echo("*** Cannot do that in this window")
    else:
      raw.send("PRIVMSG " + raw.window + " :\001PING " +
        `int(time.time())` + "\001")
  else:
    raw.send("PRIVMSG " + who + " :\001PING " + `int(time.time())` + "\001")

# QUERY
def query(nick):
  openwindow(nick)

# QUIT
def quit(reason = "I use PyIRC"):
  if reason == "":
    reason = "I use PyIRC"
  raw.send("QUIT :" + reason)

# QUOTE
def quote(command):
  if command == "":
    echo("*** Quote needs a parameter", raw.window)
  else:
    raw.send(command)

# SAY
def say(message):
  if (raw.window=="-"):
    return
  raw.send("PRIVMSG " + raw.window + " :" + message)
  if raw.window[0] == '#' or raw.window[0] == '&':
    do_on("SEND_PUBLIC", raw.window, message)
  else:
    do_on("SEND_MSG", raw.window, message)

# STATS
def stats(which, server = ""):
  if which == "":
    echo("*** Stats needs at least one parameter", raw.window)
  else:
    if server == "":
      raw.send("STATS " + which[0])
    else:
      raw.send("STATS " + which[0] + " " + server)

# TOPIC
def topic(channel, topic):
  if channel[0] != '#' and channel[0] != '&':
    topic = channel + " " + topic
    channel = raw.window
  if channel[0] != '#' and channel[0] != '&':
    echo("*** Cannot do that in this window", raw.window)
  else:
    raw.send("TOPIC " + channel + " :" + topic)

# TRACE
# TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO
# TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO

# USERHOST
# TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO
# TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO

# VERSION
def version(server = ""):
  if server == "":
    raw.send("VERSION")
  else:
    raw.send("VERSION " + server)

# WHO
# TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO
# TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO  TO DO

# WHOIS
def whois(params):
  raw.send("WHOIS " + params)

# WHOWAS
def whowas(nick, count):
  if nick == "":
    echo("*** Whowas needs a parameter", raw.window)
  elif count == "":
    raw.send("WHOWAS " + nick)
  else:
    raw.send("WHOWAS " + nick + " " + count)


##############################################
# ON

on_actions = { 'ACTION' : [], 'CHANNEL_NICK' : [],
'CHANNEL_SIGNOFF' : [], 'CONNECT' : [], 'CTCP' : [], 'CTCP_REPLY' : [],
'DCC_CHAT' : [], 'DCC_RAW' : [], 'DISCONNECT' : [], 'EXEC' : [],
'EXEC_ERRORS' : [], 'EXEC_EXIT' : [], 'EXEC_PROMPT' : [], 'FLOOD' : [],
'HOOK' : [],  'IDLE' : [], 'INPUT' : [], 'INVITE' : [], 'JOIN' : [],
'KICK' : [], 'KILL' : [], 'LEAVE' : [], 'LIST' : [], 'MAIL' : [],
'MODE' : [], 'MSG' : [], 'MSG_GROUP' : [], 'NAME' : [], 'NICKNAME' : [],
'NOTE' : [], 'NOTICE' : [], 'NOTIFY_SIGNOFF' : [], 'NOTIFY_SIGNON' : [],
'PUBLIC' : [], 'PUBLIC_MSG' : [], 'PUBLIC_NOTICE' : [], 'RAW_IRC' : [],
'SEND_ACTION' : [], 'SEND_DCC_CHAT' : [], 'SEND_MSG' : [],
'SEND_NOTICE' : [], 'SEND_PUBLIC' : [], 'SERVER_NOTICE' : [],
'SIGNOFF' : [], 'TIMER' : [], 'TOPIC' : [], 'WALL' : [], 'WALLOP' : [],
'WHO' : [], 'WINDOW_KILL' : [] }

def comp(a,b):
  if a < b:
    return -1
  elif a == b:
    return 0
  else:
    return 1

def on(what = "", how = "", action = ""):
  if what == "":
    for i in on_actions.keys():
      for j in on_actions[i]:
        echo("*** On " + i + " from \"" + j[0] + "\" do \"" + j[1] + "\"", raw.window)
    return

  what = strop.upper(what)

  if not on_actions.has_key(what):
    try:
      i = strop.atoi(what)
    except:
      echo("*** No such ON function: " + what)
      return
    if i>0 and i<1000:
      on_actions[what] = []
    else:
      echo("*** Numerics must be between 001 and 999", raw.window)

  if how == "":
    if len(on_actions[what]) == 0:
      echo("*** The " + what + " list is empty.", raw.window)
    else:
      for i in on_actions[what]:
        echo("*** On " + what + " from \"" + i[0] + "\" do \"" + i[1] + "\"", raw.window)
    return

  how = strop.upper(how)

  if action == "":
    on_actions[what] = []
    echo("*** The " + what + " list is empty.", raw.window)
  else:
    on_actions[what] = [[how, action]] + on_actions[what]


def do_on(which, p0, p1 = "", p2 = "", p3 = "", p4 = "", p5 = ""):

  if not on_actions.has_key(which):
    return 0

  globaldict = sys.modules['__main__'].__dict__

  globaldict['p0'] = p0
  globaldict['p1'] = p1
  globaldict['p2'] = p2
  globaldict['p3'] = p3
  globaldict['p4'] = p4
  globaldict['p5'] = p5

  # Ugly...
  parameters=p0
  if p1 != "":
    parameters = parameters + ' ' + p1
    if p2 != "":
      parameters = parameters + ' ' + p2
      if p3 != "":
        parameters = parameters + ' ' + p3
        if p4 != "":
          parameters = parameters + ' ' + p4
          if p5 != "":
            parameters = parameters + ' ' + p5

  paramlen = len(parameters)
  parameters = strop.upper(parameters)

  for i in on_actions[which]:
    if regex.match(i[0], parameters) == paramlen:
      eval(i[1], globaldict)
      return 1
  return 0

#################
# The default on functions

def on_action(who, to, message):
  if to == raw.nickname:
    openwindow(who)
    window = who
  else:
    openwindow(to)
    window = to

  echo("*" + who + " " + message, window)


def on_ctcp(who, to, command, args):
  if command == "ACTION":
    do_on("ACTION", who, to, args)
  elif command == "VERSION":
    echo("*** " + who + " requested your version.", "-")
    raw.send("NOTICE " + who + " :\001VERSION " + \
      vars['CLIENT_INFORMATION'] + "\001")
  elif command == "PING":
    echo("*** " + who + " pinged you.", "-")
    raw.send("NOTICE " + who + " :\001PING " + args + "\001")
  elif command == "ECHO":
    echo("*** CTCP ECHO from " + who + " : " + args, "-")
    raw.send("NOTICE " + who + " :\001ECHO " + args + "\001")
  elif command == "TIME":
    echo("*** CTCP TIME from " + who + ".", "-")
    raw.send("NOTICE " + who + " :\001TIME " + `int(time.time())` + "\001")
  elif command == "USERINFO":
    echo("*** CTCP USERINFO from " + who + ".", "-")
    raw.send("NOTICE " + who + " :\001USERINFO " + \
      vars['USER_INFORMATION'] + "\001")
  elif command == "CLIENTINFO":
    pass
  else:
    echo("*** Unknown CTCP " + command + " from " + who + " : " + args)


def on_ctcp_reply(who, command, args):
  if command == "PING":
    try:
      i = strop.atoi(args)
    except:
      i = 0
    args = `i - int(time.time())` + " second(s)."

  echo("*** CTCP " + command + " reply from " + who + " : " + args, "-")

channels_status = { }

def on_join(who, channel):
  openwindow(channel)
  nick = who[:strop.find(who, "!")]
  who = who[strop.find(who, "!") + 1:]
  if nick == raw.nickname:
    channels_status[channel] = 'JOINING'
  echo("*** " + nick + " (" + who + ") has joined channel " + channel, channel)


def on_kick(who, nick, channel, reason):
  openwindow(channel)
  if nick == raw.nickname:
    echo("*** You have been kicked of channel " + channel + " by " + who, channel)
  else:
    echo("*** " + nick + " has been kicked off channel " + channel + " by " + who + " (" + reason + ")", channel)


def on_kill(who, reason):
  echo("*** You have been killed  by " + who + " (" + reason + ")")


def on_leave(nick, channel, reason):
  if nick == raw.nickname:
    if channels_status[channel] != 'LEFT':
      channels_status[channel] = 'LEFT'
    echo("*** You have left channel " + channel)
  else:
    openwindow(channel)
    echo("*** " + nick + " has left channel " + channel + " (" + reason + ").", channel)


def on_mode(who, dest, args):
  if strop.find(who, "!") != -1:
    who = who[:strop.find(who, "!")]
  if dest == who:
    echo("*** Mode change " + args + " for user " + dest + " by " + who)
  else:
    echo("*** Mode change " + args + " on channel " + dest + " by " + who, dest)

def on_msg(who, message):
  openwindow(who)
  echo("<" + who + "> " + message, who)

def on_msg_group(who, group, message):
  echo("(" + who + "/" + group + ") " + message)

def on_nickname(oldnick, newnick):
  if oldnick == nickname:
    nickname = newnick
  for i in channels_status.keys():
     if raw.hasnick(i, oldnick):
       echo("*** " + oldnick + " is now known as " + newnick, i)
       raw.changenick(i, oldnick, newnick)

def on_notice(who, message):
  openwindow(who)
  echo("-" + who + "- " + message, who)

def on_public(who, channel, message):
  openwindow(channel)
  echo("<" + who + "> " + message, channel)

def on_public_msg(who, channel, message):
  openwindow(channel)
  echo("(" + who + ") " + message, channel)

def on_public_notice(who, channel, message):
  openwindow(channel)
  echo("-" + who + "- " + message, channel)

def on_send_action(to, message):
  openwindow(to)
  echo("* " + raw.nickname + " " + message, to)

def on_send_msg(to, message):
  openwindow(to)
  echo("<" + raw.nickname + "> " + message, to)

def on_send_notice(to, message):
  openwindow(to)
  echo("-" + raw.nickname + "- " + message, to)

def on_send_public(to, message):
  openwindow(to)
  echo("<" + raw.nickname + "> " + message, to)

def on_server_notice(server, message):
  if message[:3] != "***":
    echo("*** " + message)
  else:
    echo(message)


def on_signoff(who, reason):
  if strop.find(who, ".") == -1:
    for i in channels_status.keys():
      if raw.hasnick(i, who):
        echo("*** " + who + " has quit IRC (" + reason + ")", i)
  else:
    print 'Netsplit'

def on_topic(who, channel, newtopic):
  echo("*** " + who + " has changed the topic to : " + newtopic, channel)

def on_window_kill(w):
  if (w[0]=='#' or w[0]=='&') and (channels_status[w] != 'LEFT'):
    channels_status[w] = 'LEFT'
    raw.send("PART " + w)


######
# Numerics

def on_numeric_message(param):
  echo("*** " + param[1:])

def on_001(param):
  nickname = raw.nickname
  echo("*** " + param[strop.find(param, ":") + 1:])

def on_002(param):
  echo("*** " + param[1:])

def on_003(param):
  echo("*** " + param[1:])

def on_004(param):
  param = param[strop.find(param, " ")+1:]
  param = param[strop.find(param, " ")+1:]
  echo("*** User modes available " + param[:strop.find(param, " ")] + ", channel modes available " + param[strop.find(param, " ")+1:])

# Command replies

def on_221(param):
  echo("*** Your user mode is \"" + param + "\".")

def on_251(param):
  echo("*** " + param[1:] + ".")

def on_252(param):
  echo("*** " + param[:strop.find(param, ":")] + "operator(s) online.")

def on_253(param):
  echo("*** " + param[:strop.find(param, ":")] + "unknown connection(s).")

def on_254(param):
  echo("*** " + param[:strop.find(param, ":")] + "channels have been formed.")

def on_255(param):
  echo("*** " + param[1:] + ".")

def on_256(param):
  echo("*** Administrative info about " + param[:strop.find(param, " ")] +" :")

def on_257(param):
  echo("*** " + param[1:] + ".")

def on_258(param):
  echo("*** " + param[1:] + ".")

def on_259(param):
  echo("*** " + param[1:] + ".")

def on_301(param):
  echo("*** " + param[:strop.find(param, " ")] + " is away : " + param[strop.find(param, ":")+1:])

#def on_302(param):
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO

#def on_303(param):
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO

def on_305(param):
  echo("*** You are no longer marked as being away.")

def on_306(param):
  echo("*** You have been marked as being away.")

def on_311(param):
  n = param[:strop.find(param, " ")]
  param = param[strop.find(param, " ")+1:]
  u = param[:strop.find(param, " ")]
  param = param[strop.find(param, " ")+1:]
  h = param[:strop.find(param, " ")]
  echo("*** Whois informations for " + n + " :")
  echo("*** Address     : " + u + "@" + h)
  echo("*** IRCName     : " + param[strop.find(param, ":")+1:])

def on_312(param):
  param = param[strop.find(param, " ")+1:]
  echo("*** On server   : " + param[:strop.find(param, " ")] + " (" + param[strop.find(param, ":")+1:] + ")")

def on_313(param):
  echo("*** " + param[:strop.find(param, " ")] + " is an IRC operator.")

def on_314(param):
  n = param[:strop.find(param, " ")]
  param = param[strop.find(param, " ")+1:]
  u = param[:strop.find(param, " ")]
  param = param[strop.find(param, " ")+1:]
  h = param[:strop.find(param, " ")]
  echo("*** Whowas informations for " + n + " :")
  echo("*** Address     : " + u + "@" + h)
  echo("*** IRCName     : " + param[strop.find(param, ":")+1:])

#def on_315(param):
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO

def on_317(param):
  param = param[strop.find(param, " ")+1:]
  echo("*** Idle time   : " + param[:strop.find(param, " ")] + " second(s).")

def on_318(param):
  pass

def on_319(param):
  param = param[strop.find(param, " ")+1:]
  echo("*** On channels : " + param[strop.find(param, ":")+1:])

def on_324(param):
  pass

def on_329(param):
  c = param[:strop.find(param," ")]
  param = param[strop.find(param," ")+1:]
  echo("*** Channel created on " + \
    stime(strop.atoi(param))[4:19], c)

def on_331(param):
  echo("*** No topic is set.")

def on_332(param):
  pass

def on_333(param):
  c = param[:strop.find(param, " ")]
  param = param[strop.find(param, " ")+1:]
  w = param[:strop.find(param, " ")]
  param = param[strop.find(param, " ")+1:]
  echo("*** Topic set by " + w + " on " + \
    stime(strop.atoi(param))[4:19], c)

def on_341(param):
  c = param[:strop.find(param," ")]
  param = param[strop.find(param," ")+1:]
  if c == raw.window:
    echo("*** Inviting " + param + ".")
  else:
    echo("*** Inviting " + param + " to channel " + c + ".")

def on_351(param):
  v = param[:strop.find(param," ")]
  param = param[strop.find(param," ")+1:]
  s = param[:strop.find(param," ")]
  echo("*** Server " + s + " is version " + v + "(" + param[strop.find(param,":")+1:] + ").")

#def on_352
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO
# TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO

def on_353(param):
  param = param[strop.find(param, " ") + 3:]
  channel = param[:strop.find(param, " ")]
  param = param[strop.find(param,":") + 1:]
  if channels_status.has_key(channels_status) and channels_status[channel] == 'JOINING':
    echo("*** Names on channel " + channel + " : " + param, channel)
  else:
    echo("*** Names on channel " + channel + " : " + param, raw.window)

def on_364(param):
  pass

def on_365(param):
  pass

def on_366(param):
  if channels_status[channel] == 'JOINING':
    channels_status[channel] = 'ON'

def on_367(param):
  pass

def on_368(param):
  pass

def on_369(param):
  pass

def on_371(param):
  echo("*** " +param[1:])

def on_372(param):
  if vars['SUPPRESS_SERVER_MOTD'] == 0 or vars['__FIRST_MOTD'] == 0:
    echo("*** " + param[3:])

def on_374(param):
  pass

def on_375(param):
  if vars['SUPPRESS_SERVER_MOTD'] == 0 or vars['__FIRST_MOTD'] == 0:
    param = param[3:]
    echo("*** Message of the day of server " + \
      param[:strop.find(param, " ")] + " :")

def on_376(param):
  if vars['SUPPRESS_SERVER_MOTD'] == 0 or vars['__FIRST_MOTD'] == 0:
    echo("*** End of MOTD.")
  vars['__FIRST_MOTD']=0

def on_381(param):
  echo("*** You are now an IRC operator.")

def on_382(param):
  echo("*** Rehashing.")

def on_391(param):
  echo("*** Date at " + param[:strop.find(param," ")] + " is " + param[strop.find(param,":")+1:] + ".")

# Error messages

def on_401(param):
  
  echo("*** " + param[:strop.find(param, " ")] + " : No such nick/channel.")

def on_402(param):
  echo("*** " + param[:strop.find(param, " ")] + " : No such server.")

def on_403(param):
  echo("*** " + param[:strop.find(param, " ")] + " : No such channel.")

def on_404(param):
  echo("*** Cannot send to channel " + param[:strop.find(param, " ")] + ".")

def on_405(param):
  echo("*** Cannot join channel " + param[:strop.find(param, " ")] + " : You have joined too many channels.")

def on_406(param):
  echo("*** " + param[:strop.find(param, " ")] + " : There was no such nickname.")

def on_407(param):
  echo("*** " + param[:strop.find(param, " ")] + " : Duplicate recipients. No message delivered.")

def on_409(param):
  echo("*** No origin specified.")

def on_411(param):
  echo("*** " + param[strop.find(param,":")+1:] + ".")

def on_412(param):
  echo("*** No text to send.")

def on_413(param):
  echo("*** No toplevel domain specified for wildcard " + param[:strop.find(param," ")])

def on_414(param):
  echo("*** Wildcard in toplevel domain : " + param[:strop.find(param," ")])

def on_421(param):
  echo("*** Unknown command : " + param[:strop.find(param," ")])

def on_422(param):
  echo("*** MOTD File is missing")

def on_423(param):
  echo("*** No administrative info available for " + param[:strop.find(param," ")] + ".")

def on_424(param):
  echo("*** " + param[strop.find(param,":")+1:] + ".")

def on_431(param):
  echo("*** No nickname given.")

def on_432(param):
  echo("*** " + param[:strop.find(param," ")] + " is an erroneous nickname.")

def on_433(param):
  param = param[strop.find(param," ")+1:]
  echo("*** Nickname " + param[:strop.find(param," ")] + " is already in use.")

def on_436(param):
  echo("*** Nickname collision kill.")

# Is it used by the server ?
def on_441(param):
  n = param[:strop.find(param," ")]
  param = param[strop.find(param, " ")+1:]
  echo("*** " + n + " is not on channel " + param[:strop.find(param," ")])

def on_442(param):
  echo("*** You're not on channel " + param[:strop.find(param," ")] + ".")

def on_443(param):
  n = param[:strop.find(param," ")]
  param = param[strop.find(param, " ")+1:]
  echo("*** " + n + " is already on channel " + param[:strop.find(param," ")])

def on_451(param):
  echo("*** You have not registered.")

def on_461(param):
  echo("*** Not enough parameters for " + param[:strop.find(param," ")] + ".")

def on_462(param):
  echo("*** You may not reregister.")

def on_463(param):
  echo("*** Your host isn't among the privileged.")

def on_464(param):
  echo("*** Password incorrect.")

def on_465(param):
  echo("*** You are banned from this server.")

def on_467(param):
  echo("*** Channel key already set.", param[:strop.find(param," ")])

def on_471(param):
  echo("*** Cannot join channel " + param[:strop.find(param," ")] + " (+l).")

def on_472(param):
  echo("*** " + param[:strop.find(param," ")] + " is unknown mode char to me.")

def on_473(param):
  echo("*** Cannot join channel " + param[:strop.find(param," ")] + " (+i).")

def on_474(param):
  echo("*** Cannot join channel " + param[:strop.find(param," ")] + " (+b).")

def on_475(param):
  echo("*** Cannot join channel " + param[:strop.find(param," ")] + " (+k).")

def on_481(param):
  echo("*** Permission denied, you're not an IRC operator.")

def on_482(param):
  echo("*** Permission denied, you're not channel operator.", param[:strop.find(param," ")])

def on_483(param):
  echo("*** You cannot kill a server!")

def on_491(param):
  echo("*** No O-lined for you host.")

def on_501(param):
  echo("*** Unknown mode flag.")

def on_502(param):
  echo("*** Cannot change mode for other users.")


####
# Setup

on("ACTION",".*","pyirc.on_action(p0,p1,p2)")
on("CTCP",".*","pyirc.on_ctcp(p0,p1,p2,p3)")
on("CTCP_REPLY", ".*", "pyirc.on_ctcp_reply(p0,p1,p2)")
on("JOIN", ".*", "pyirc.on_join(p0,p1)")
on("KICK", ".*", "pyirc.on_kick(p0,p1,p2,p3)")
on("KILL", ".*", "pyirc.on_kill(p0,p1)")
on("LEAVE", ".*", "pyirc.on_leave(p0,p1,p2)")
on("MODE", ".*", "pyirc.on_mode(p0,p1,p2)")
on("MSG", ".*", "pyirc.on_msg(p0,p1)")
on("MSG_GROUP", ".*", "pyirc.on_msg_group(p0,p1,p2)")
on("NICKNAME", ".*", "pyirc.on_nickname(p0,p1)")
on("NOTICE", ".*", "pyirc.on_notice(p0,p1)")
on("PUBLIC", ".*", "pyirc.on_public(p0,p1,p2)")
on("PUBLIC_MSG", ".*", "pyirc.on_public_msg(p0,p1,p2)")
on("PUBLIC_NOTICE", ".*", "pyirc.on_public_notice(p0,p1,p2)")
on("SEND_ACTION", ".*", "pyirc.on_send_action(p0,p1)")
on("SEND_MSG", ".*", "pyirc.on_send_msg(p0,p1)")
on("SEND_NOTICE", ".*", "pyirc.on_send_notice(p0,p1)")
on("SEND_PUBLIC", ".*", "pyirc.on_send_public(p0,p1)")
on("SERVER_NOTICE", ".*", "pyirc.on_server_notice(p0,p1)")
on("SIGNOFF", ".*", "pyirc.on_signoff(p0,p1)")
on("TOPIC", ".*", "pyirc.on_topic(p0,p1,p2)")
on("WINDOW_KILL", ".*", "pyirc.on_window_kill(p0)")

# Command replies
on("001", ".*", "pyirc.on_001(p0)")
on("002", ".*", "pyirc.on_002(p0)")
on("003", ".*", "pyirc.on_003(p0)")
on("004", ".*", "pyirc.on_004(p0)")
on("221", ".*", "pyirc.on_221(p0)")
on("251", ".*", "pyirc.on_251(p0)")
on("252", ".*", "pyirc.on_252(p0)")
on("253", ".*", "pyirc.on_253(p0)")
on("254", ".*", "pyirc.on_254(p0)")
on("255", ".*", "pyirc.on_255(p0)")
on("256", ".*", "pyirc.on_256(p0)")
on("257", ".*", "pyirc.on_257(p0)")
on("258", ".*", "pyirc.on_258(p0)")
on("259", ".*", "pyirc.on_259(p0)")
on("301", ".*", "pyirc.on_301(p0)")
on("305", ".*", "pyirc.on_305(p0)")
on("306", ".*", "pyirc.on_306(p0)")
on("311", ".*", "pyirc.on_311(p0)")
on("312", ".*", "pyirc.on_312(p0)")
on("313", ".*", "pyirc.on_313(p0)")
on("314", ".*", "pyirc.on_314(p0)")
on("317", ".*", "pyirc.on_317(p0)")
on("318", ".*", "pyirc.on_318(p0)")
on("319", ".*", "pyirc.on_319(p0)")
on("324", ".*", "pyirc.on_324(p0)")
on("329", ".*", "pyirc.on_329(p0)")
on("331", ".*", "pyirc.on_331(p0)")
on("332", ".*", "pyirc.on_332(p0)")
on("333", ".*", "pyirc.on_333(p0)")
on("341", ".*", "pyirc.on_341(p0)")
on("351", ".*", "pyirc.on_351(p0)")
on("353", ".*", "pyirc.on_353(p0)")
on("364", ".*", "pyirc.on_364(p0)")
on("365", ".*", "pyirc.on_365(p0)")
on("366", ".*", "pyirc.on_366(p0)")
on("367", ".*", "pyirc.on_367(p0)")
on("368", ".*", "pyirc.on_368(p0)")
on("369", ".*", "pyirc.on_369(p0)")
on("371", ".*", "pyirc.on_371(p0)")
on("372", ".*", "pyirc.on_372(p0)")
on("374", ".*", "pyirc.on_374(p0)")
on("375", ".*", "pyirc.on_375(p0)")
on("376", ".*", "pyirc.on_376(p0)")
on("381", ".*", "pyirc.on_381(p0)")
on("382", ".*", "pyirc.on_382(p0)")
on("391", ".*", "pyirc.on_391(p0)")

# Error messages
on("401", ".*", "pyirc.on_401(p0)")
on("402", ".*", "pyirc.on_402(p0)")
on("403", ".*", "pyirc.on_403(p0)")
on("404", ".*", "pyirc.on_404(p0)")
on("405", ".*", "pyirc.on_405(p0)")
on("406", ".*", "pyirc.on_406(p0)")
on("407", ".*", "pyirc.on_407(p0)")
on("409", ".*", "pyirc.on_409(p0)")
on("411", ".*", "pyirc.on_411(p0)")
on("412", ".*", "pyirc.on_412(p0)")
on("413", ".*", "pyirc.on_413(p0)")
on("414", ".*", "pyirc.on_414(p0)")
on("421", ".*", "pyirc.on_421(p0)")
on("422", ".*", "pyirc.on_422(p0)")
on("423", ".*", "pyirc.on_423(p0)")
on("424", ".*", "pyirc.on_424(p0)")
on("431", ".*", "pyirc.on_431(p0)")
on("432", ".*", "pyirc.on_432(p0)")
on("433", ".*", "pyirc.on_433(p0)")
on("436", ".*", "pyirc.on_436(p0)")
on("441", ".*", "pyirc.on_441(p0)")
on("442", ".*", "pyirc.on_442(p0)")
on("443", ".*", "pyirc.on_443(p0)")
on("451", ".*", "pyirc.on_451(p0)")
on("461", ".*", "pyirc.on_461(p0)")
on("462", ".*", "pyirc.on_462(p0)")
on("463", ".*", "pyirc.on_463(p0)")
on("464", ".*", "pyirc.on_464(p0)")
on("465", ".*", "pyirc.on_465(p0)")
on("466", ".*", "pyirc.on_466(p0)")
on("471", ".*", "pyirc.on_471(p0)")
on("472", ".*", "pyirc.on_472(p0)")
on("473", ".*", "pyirc.on_473(p0)")
on("474", ".*", "pyirc.on_474(p0)")
on("475", ".*", "pyirc.on_475(p0)")
on("481", ".*", "pyirc.on_481(p0)")
on("482", ".*", "pyirc.on_482(p0)")
on("483", ".*", "pyirc.on_483(p0)")
on("491", ".*", "pyirc.on_491(p0)")
on("501", ".*", "pyirc.on_501(p0)")
on("502", ".*", "pyirc.on_502(p0)")

###################
# The 'set' function
#
vars = { \
  'SUPPRESS_SERVER_MOTD' : 0, \
  '__FIRST_MOTD' : 1, \
  'USER_INFORMATION' : '<None supplied>', \
  'CLIENT_INFORMATION' : "Running PyIRC version " + VERSION_NUMBER + \
      " - You'll love it." \
}

def set(var, value):
  var = strop.upper(var)
  if vars.has_key(var):
    vars[var] = value
