/*
 *  MessageWindow.cpp - The window type for queries
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <Python.h>

#include "Util.h"
#include "PyIRC.h"
#include "MessageWindow.h"

extern PyIRC *mainWindow;

MessageWindow::MessageWindow(String nickname)
  : LoggingWindow(nickname)
{
}

MessageWindow::~MessageWindow()
{
}

void
MessageWindow::handleInput()
{
  String message = messageEdit->text();

  if (message == "")
    return;

  messageEdit->setText("");

  if (message[0]=='/')
    Parser::parseCommand(getName(), message);
  else
    if (mainWindow->registered) {
      Util::send(mainWindow->getSock(), String("PRIVMSG ") + getName() +
        " :" + message);
      Util::do_on(3, "SEND_MSG", getName().chars(),
        message.chars());
    }
}
