#include <qpainter.h>
#include "PopMenu.h"

#include <iostream.h>

PopMenu::PopMenu(const char *title)
  : QPopupMenu()
{
  insertItem(title);
  insertSeparator();
}

PopMenu::~PopMenu()
{
}

void
PopMenu::paintCell(QPainter *p, int row, int col)
{
  if (row)
    QPopupMenu::paintCell(p, row, col);
  else if (!col) {
    int w = totalWidth();
    int h = cellHeight(0);
    QColorGroup cg = colorGroup();

    p->setPen(cg.light());
    p->drawText(1, 1, w, h, AlignCenter, text(0));
    p->setPen(cg.text());
    p->drawText(0, 0, w, h, AlignCenter, text(0));
  }
}
