/*
 *  User.cpp - The user object (for channels)
 *  Copyright (c) 1997 Etienne Bernard (eb@via.ecp.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <bool.h>

#include "User.h"

User::User(String nick) {
  nickname = nick;
  voice = chanop = FALSE;
}

void
User::setVoice(bool voiced)
{
  voice = voiced;
}

void
User::setChanop(bool chanoped)
{
  chanop = chanoped;
}

String
User::toString(void)
{
  String s = "";
  if (chanop)
    s += "@";
  else if (voice)
         s += "+";
  s+=nickname;
  return s;
}
